'' SPUDVIEW_uOLED-128-G 0.2
'' BY JEFF LEDGER

'' Set filename below to load picture.
'' Files must be on your SD card.
''
'' File Format must be 128x128 Raw .PPM (Can be created by Gimp)
''
'' Files are displayed for 1 min, then the uOLED is shutdown.

CON
  _CLKMODE = xtal1 + pll16x
  _XINFREQ = 5_000_000


   spiDO     = 3
   spiClk    = 4
   spiDI     = 5
   spiCS     = 6

VAR

  '' SD Vars
  byte f0[32]
  byte tbuf[20]
  long ioControl[2]
  long tp

OBJ
     OLED  : "uOLED-128-GMD1"
     DELAY : "Clock"
     fsrw  : "fsrwFemto"

PUB start |  c, o, d, p , counter,count,row,col,pos,r,b,g,totalcol

    delay.init(5000000)
    fsrw.start(@ioControl)
    fsrw.mount(spiDO,spiClk,spiDI,spiCS)

    fsrw.popen(string("flowers.ppm"),"r")

    OLED.INIT
    DELAY.PauseSec(1)
    SETUP
    OLED.BACKGROUND(0,0,0)

    totalcol:=127
    repeat
      pos:=fsrw.pgetc
      if pos<0
        quit
      if pos==10
        count++

      if count>3 '' BYPASS HEADER DATA TO ACTUAL RAW RGB VALUES
       repeat until row==128
         r:=0
         g:=0
         b:=0

         r:=fsrw.pgetc ''GET RED VALUE
           if r<0
             quit


         g:=fsrw.pgetc ''GET BLUE VALUE
           if g<0
             quit


         b:=fsrw.pgetc ''GET GREEN VALUE
           if b<0
             quit

         OLED.PUT_PIXEL(col,row, r,g,b)
         col++

         if col>totalcol
            col:=0
            row++
         counter++

    counter:=0
    repeat until counter == 60
      DELAY.pauseSec(1)    '' Allow the image to be displayed for 1 min
      counter++

    SHUTDOWN              '' Proper Shutdown
    repeat
     delay.pauseMSec(1)

PUB SETUP
  OLED.ERASE
  DELAY.PauseMSec(60)
  OLED.BACKGROUND(0,0,0)

PUB SHUTDOWN | Temp
  OLED.ERASE
  OLED.BACKGROUND(0,0,0)
  OLED.OPAQUE

  OLED.FTEXT(2,2, 0, 255,255,255, string("Shutdown in:"),0)
  'OLED.FONT_SIZE(2)
  OLED.UCHAR("5", 90,8, 250,250,0, 2,2)

  OLED.FTEXT(3,8, 0, 250,250,0, string("Thanks!!"),0)
  DELAY.pauseSec(1)
  OLED.UCHAR("4", 90,8, 0,250,0, 2,2)
  DELAY.pauseSec(1)
  OLED.UCHAR("3", 90,8, 250,250,0, 2,2)
  DELAY.pauseSec(1)
  OLED.UCHAR("2", 90,8, 250,250,0, 2,2)
  DELAY.pauseSec(1)
  OLED.UCHAR("1", 90,8, 250,0,0, 2,2)
  DELAY.PauseSec(1)
  OLED.UCHAR("0", 90,8, 250,0,0, 2,2)
  DELAY.PauseSec(1)

  OLED.ERASE
  DELAY.PauseMSec(20)

  OLED.POWER(0)
  DELAY.PauseSec(4)
  OLED.POWER(1)
  DELAY.PauseMSec(500)
  'OLED.RESET
  OLED.AUTO_BAUD
  SETUP
